#|------------------------------------------------------------*-Scheme-*--|
 | File:	    modules/corelib/complex.scm
 |
 |          Contributed by HIROSHI OOTA <oota@POBoxes.com>
 |          as part of the RScheme project, licensed for free use.
 |          See <http://www.rscheme.org/> for the latest info.
 |
 | File version:     1.1
 | File mod date:    1998.12.28 10:31:29
 | System build:     v0.7.3.1-b39, 1999-12-25
 | Owned by module:  corelib
 |
 | Purpose:          complex number handling
 `------------------------------------------------------------------------|#

(define-safe-glue (make-rectangular (re <number>) (im <number>))
{
#if !FULL_NUMERIC_TOWER
    scheme_error( "complex.scm:make-rectanglar:~s: function stubbed out", 1, int2fx(__LINE__) ); 
    REG0 = ZERO;
    RETURN1();
#else
  REG0 = make_complex_obj(re, im);
  RETURN1();
#endif
})


(define-generic-function real-part)
(define-generic-function imag-part)
(define-method real-part ((self <rect-complex>))
  (re self))
(define-method imag-part ((self <rect-complex>))
  (im self))
