#|------------------------------------------------------------*-Scheme-*--|
 | File:	    packages/rstore/module.scm
 |
 |          Copyright (C)1998 Donovan Kolbly <d.kolbly@rscheme.org>
 |          as part of the RScheme project, licensed for free use.
 |	    See <http://www.rscheme.org/> for the latest info.
 |
 | File version:     1.2
 | File mod date:    1999.03.18 09:34:51
 | System build:     v0.7.3.1-b39, 1999-12-25
 | Owned by module:  rs.db.rstore
 |
 | Purpose:          Module control file
 `------------------------------------------------------------------------|#

(define-module rs.db.rstore ()
  (&module
   (import rs.lang)
   (import rs.lang.internal)
   (import rs.sys.paths)
   (import rs.sys.tables)
   (import rs.db.lss)
   (import rs.glue)
   (import rs.sys.linker))
  ;
#| -- can't make this work yet for `rsc' -- see CR 771
  (&module (import rs.util.msgs))
  (define-message-table rs.db.rstore 463)

  #- rs.db.rstore/debug (define-macro (dm . opts) (values))
|#

  (define-macro (dm . opts) (values))
  (define-macro (em num msg . opts)
    `(error ,(format #f "463-~03dE ~a" num msg) ,@opts))

  (&module
   ;;
   (load "../lss/glue.scm")
   (load "glue.scm")
   (load "pstore.scm")
   (load "copyin.scm")
   (load "indir.scm")
   (load "commit.scm")
   ;;
   (export open-persistent-store
	   create-persistent-store
	   read-persistent-store
	   close-persistent-store
	   commit
	   set-compression-method
	   root-object
	   set-root-object!
	   register-indirect-page
	   default-allocation-area
	   
	   num-dirty-pages
	   object->allocation-area
	   <persistent-store>
	   make-allocation-area
	allocation-area->store
	   )))
