/*-----------------------------------------------------------------*-C-*---
 * File:    handc/platform/aix/dynlink.c
 *
 *          Copyright (C)1997 Donovan Kolbly <d.kolbly@rscheme.org>
 *          as part of the RScheme project, licensed for free use.
 *          See <http://www.rscheme.org/> for the latest information.
 *
 * File version:     1.5
 * File mod date:    1998.01.03 19:02:18
 * System build:     v0.7.3.1-b39, 1999-12-25
 *
 * Purpose:          AIX dynamic linking interface
 *------------------------------------------------------------------------*/

#include <stdio.h>
#include <sys/ldr.h>
#include <rscheme/linktype.h>

typedef struct export_table *module_init_fn( void );

void *resolve_link_symbol( void *info, const char *sym )
{
struct export_table *t = (struct export_table *)info;

    assert(t);
    while (t->name)
      {
	if (strcmp(sym,t->name) == 0)
	  return t->value;
	t++;
      }
    return NULL;
}

void *dynamic_link_file( const char *path )
{
module_init_fn *entry_fn;

  /* "." is the library path */

  entry_fn = (module_init_fn *)load( (char *)path, 1, "." );

  if (entry_fn)
    return entry_fn();
  else
    return NULL;
}

char *dynamic_link_errors( void )
{
  return NULL;
}

void done_resolving( void *info )
{
}

void init_dynamic_link( const char *argv0 )
{
}
